import { characterData } from "../characterData.js";
import { userData } from "../userData.js";

export enum loginResult{
    success,
    fail,
    accountExists
}

export class loginResponse{
    result : loginResult
    userData : userData
    playerData : characterData

    constructor(result: loginResult, user : userData, player : characterData){
        if (!user || !player){
            this.result = result;
            this.userData = this.playerData = null;
        }
        else{
            this.result = result;
            this.userData = user.makeSafe();
            this.playerData = player;
        }
    }
}