import { characterData } from "../characterData.js"
import { enemyDamageInfo } from "../enemyDamageInfo.js"
import { physicsObject } from "../physicsObject.js"
import { playerInventory } from "../playerInventory.js"

export class characterDataStart{
    id : number
    characterId : number
    rigidbody : physicsObject = new physicsObject()

    constructor(data : characterData){
        this.id = data.id
        this.characterId = data.characterId
        this.rigidbody = physicsObject.characterOnly(data.rigidbody)
    }
}

export class characterDataUpdate{
    id : number
    rigidbody : physicsObject = new physicsObject()
    damageInfo : enemyDamageInfo[] = []

    constructor(data : characterData){
        this.id = data.id
        this.rigidbody = physicsObject.characterOnly(data.rigidbody)
        if(data.damageInfo.length > 0){
            this.damageInfo = data.damageInfo
        }
    }
}

export class characterDataInventory{
    id : number
    inventory : playerInventory = new playerInventory()

    constructor(data : characterData){
        this.id = data.id
        this.inventory = data.inventory
    }
}