import { inventoryChange } from "../Classes/Incoming/inventoryChange.js";
import { itemData } from "../Classes/itemData.js";
import { characterData } from "../Classes/characterData.js";
import { Socket } from "socket.io";

export function updateInventory(socket : Socket, data){
        let buff = Buffer.from(data, 'base64');
        let data1 : inventoryChange[] = JSON.parse(buff.toString('utf-8'));

        let player : characterData = socket.character
        let inventory = player.inventory

        data1.forEach(change=>{
            switch(change.operation){
                case 0: //None
                    break;
                case 1: //ItemAdd
                {
                    let item = itemData.copy(change.item)
                    inventory.items.push(item)
                    break;
                }
                case 2: //ItemChangeStack
                {
                    let itemStack = inventory.items.find(i=>i.id == change.item.id)
                    itemStack.count += change.item.count
                    break;
                }
                case 3: //ItemRemove
                {
                    let itemStack = inventory.items.findIndex(i=>i.id == change.item.id)
                    inventory.items.splice(itemStack, 1)
                    break;
                }
                case 4: //EquipmentChange
                {
                    inventory.equipment[change.itemSlot] = change.item.id
                    break;
                }
            }
        })
}