import { itemData, persistentItemData } from "../Classes/itemData.js";
import {game} from "../game.js";

function getRandom(arr){
    return arr[Math.floor(Math.random()*arr.length)]
}

export function generateItemByType(itemType : number){
    let items = game.itemsDB.filter(i=>i.itemType == itemType)

    if(items.length == 0){
        console.log("Error, can't generate item type " + itemType)
        return null
    }
    else{
        let itemTemplate : persistentItemData = getRandom(items)
        let item = itemData.fromPersistentData(itemTemplate)
        return item
    }
}