import { Socket } from "socket.io";
import { levelUpdateClient } from "../Classes/Incoming/levelUpdateClient.js";
import { characterData } from "../Classes/characterData.js";

export function playerUpdate(socket : Socket, data){
    if(socket.user != null) return;

    let buff = Buffer.from(data, 'base64');
    let data1 : levelUpdateClient = JSON.parse(buff.toString('utf-8'));

    let character : characterData = socket.character
    if(character == null){
        console.log("Error! Player not spawned!")
        return
    }
    
    character.rigidbody = data1.player.rigidbody
    if(data1.player.hasOwnProperty("damageInfo"))
        character.damageInfo = character.damageInfo.concat(data1.player.damageInfo)
}