import { Endpoints } from "../endpoints.js";
import { clear } from "./_clear.js";
import { enter } from "./_enter.js";
import { playerUpdate } from "./_playerUpdate.js";
import { projectile } from "./_projectile.js";
import { update } from "./_update.js";

export function registerLevelCallbacks(socket){
    socket.on(Endpoints.LevelEnter, (data) => {
        enter(socket, data)
    });

    socket.on(Endpoints.LevelCleared, (data) => {
        clear(socket, data)
    });

    socket.on(Endpoints.LevelUpdate, (data) => {
        update(socket, data)
    });

    socket.on(Endpoints.LevelPlayerUpdate, (data) => {
        playerUpdate(socket, data)
    });

    socket.on(Endpoints.LevelProjectile, (data) => {
        projectile(socket, data)
    });
}
