import { characterData } from "./Classes/characterData.js"
import { userData } from "./Classes/userData.js"
import { Socket, Server as SocketIOServer } from 'socket.io';

declare module 'socket.io' {
  interface Socket {
    io: SocketIOServer
    user: userData
    character: characterData
  }
}

export class SocketExtended extends Socket
{
  validateUser() : boolean
  {
    return this.user != null;
  }

  validateCharacter() : boolean
  {
    return this.character != null;
  }
}
